@echo off
REM ********************************************************************
REM (C) Copyright IBM Corp.  2005-2006
REM The source code for this program is not published or otherwise
REM divested of its trade secrets, irrespective of what has been
REM deposited with the U.S. Copyright Office.
REM ********************************************************************




@echo *************************************************************************************************************
@echo 				WELCOME TO RATIONAL PORTFOLIO MANAGER v7.0.1.1 MIGRATION
@echo *************************************************************************************************************

set LOG_DIR="%CD%"\Logs\
if NOT EXIST %LOG_DIR% MKDIR %LOG_DIR%
set CSP_DIR=..\csp\
set MIG_DIR="%CD%"

set DB=
set USR=
set PWRD=
set DBUSER=
set DBPASS=
set TBSCHEM=
set ALIAS=
set VERSION=
set response=
set TABLE_COUNT=
set INDEX_COUNT=
set TRIGGER_COUNT=
set FUNCTION_COUNT=
set PROC_COUNT=
set ERRORLEVEL=0



if EXIST "%DB2TEMPDIR%"function\IBMRPM_7000.dll (del "%DB2TEMPDIR%"function\IBMRPM.dll
rename "%DB2TEMPDIR%"function\IBMRPM_7000.dll IBMRPM.dll
if %ERRORLEVEL%  NEQ 0 goto :rename_error
)

if EXIST "%DB2TEMPDIR%"function\unfenced\IBMRPM_7000.dll (del "%DB2TEMPDIR%"function\unfenced\IBMRPM.dll
rename "%DB2TEMPDIR%"function\unfenced\IBMRPM_7000.dll IBMRPM.dll
if %ERRORLEVEL%  NEQ   0 goto :rename_error)


@echo Renaming IBMRPM.dll file located in "%DB2TEMPDIR%"function\ and "%DB2TEMPDIR%"function\unfenced directories to IBMRPM_7000.dll for backup....
if NOT EXIST "%DB2TEMPDIR%"function\IBMRPM_7000.dll (rename "%DB2TEMPDIR%"function\IBMRPM.dll IBMRPM_7000.dll
if %ERRORLEVEL%  NEQ   0 goto :rename_error)
if NOT EXIST "%DB2TEMPDIR%"function\unfenced\IBMRPM_7000.dll (rename "%DB2TEMPDIR%"function\unfenced\IBMRPM.dll IBMRPM_7000.dll
if %ERRORLEVEL%  NEQ   0 goto :rename_error)



@echo Copying "%CSP_DIR%"IBMRPM.dll into "%DB2TEMPDIR%"function\ and "%DB2TEMPDIR%"function\unfenced folders....
if NOT EXIST "%DB2TEMPDIR%"function\IBMRPM.dll (copy "%CSP_DIR%"IBMRPM.dll "%DB2TEMPDIR%"function\
if %ERRORLEVEL%  NEQ   0 goto :copy_error)
if NOT EXIST "%DB2TEMPDIR%"function\unfenced\IBMRPM.dll copy "%CSP_DIR%"IBMRPM.dll "%DB2TEMPDIR%"function\unfenced
if %ERRORLEVEL%  NEQ   0 goto :copy_error


@echo Please enter the database name to be migrated...
Set /P DB=
if "%DB%" == "" (@echo The database name cannot be blank, provide valid database name....
set /P DB=
)

@echo Please enter the username of the instance owner...
Set /P USR=

if "%USR%" == "" (@echo The username of the instance owner cannot be blank, provide valid username....
set /P USR=
)


@echo Please enter the password of the instance owner...
Set /P PWRD=
if "%PWRD%" == "" (@echo The password of the instance owner cannot be blank, provide a valid password...
set /P PWRD=
)

@echo Please enter the username of the connected user if any or leave it blank...
Set /P DBUSER=
if "%DBUSER%" == "" (SET ALIAS="N"
SET DBPASS="EMPTY"

)
if "%DBUSER%" == "%USR%" (@echo The username of the connected user and the instance owner can't be the same.
@echo Please enter a valid username for the connected user or leave it blank if you don't have the connected user...
set DBUSER=
Set /P DBUSER=

if "%DBUSER%" == ""  (set ALIAS="N"
set DBPASS="EMPTY"

)
if "%DBUSER%" == "%USR%" (@echo You can't have the same username for the connected user and the instance owner.
@echo Ignoring the connected user, continuing the migration using only the instance owner credentials.
set ALIAS="N"
set DBPASS="EMPTY"

)
)


if "%DBUSER%" NEQ "" if "%DBUSER%" NEQ "%USR%" (
set ALIAS="Y"

)







if %ALIAS% == "Y" (@echo Please enter the password for the connected user...   
Set /P DBPASS=
)
if "%DBPASS%" == "" (@echo The password for the connected user cannot be blank, provide valid password....
set /P DBPASS=
)

set TBSCHEM=%USR%



@echo Restarting DB2 instance....
@echo -----------------------------------------------------------------------------------------------------------------
db2 force applications all
db2stop force
db2start
@echo -----------------------------------------------------------------------------------------------------------------
@echo If no errors encountered during the startup of DB2 instance
pause

db2 connect to %DB% user %USR% using %PWRD%
if %ERRORLEVEL%  NEQ   0 goto :error_connect

db2 -x "SELECT 'SET VERSION=' || CAST(ELEMENT_NAME AS CHAR(7)) FROM TMT_SETTINGS WHERE ELEMENT_ID='CLIENT_VERSION_NUMBER'" > %LOG_DIR%version.bat

CALL %LOG_DIR%version.bat

if "%VERSION%" == "7.0.1.1" (@echo Your database is already migrated to RPM v%VERSION%. Exiting the migration.

goto :done
)

if %VERSION% NEQ 7.0.0.0 (@echo Your database is not at the right level "7.0.0.0"
@echo You need to upgrade your database to RPM v7.0.0.0 level first,then upgrade to RPM v7.0.1.1 level.
goto :done
)


@echo Starting migration from RPM v7.0.0.0 to RPM v7.0.1.1.....
@echo -----------------------------------------------------------------------------------------------------------------
db2 connect to %DB% user %USR% using %PWRD%
if %ERRORLEVEL%  NEQ   0 goto :error_connect 

db2 SET CURRENT SCHEMA %TBSCHEM%
if %ERRORLEVEL%  NEQ   0 goto :error_schema 

db2 -tvf migration7011.sql > %LOG_DIR%migration7011.out

@echo Running Statistics......
@echo -----------------------------------------------------------------------------------------------------------------
db2 connect to %DB% user %USR% using %PWRD%
if %ERRORLEVEL%  NEQ   0 goto :error_connect 
call Reorgstats70 %TBSCHEM% > %LOG_DIR%Reorgstats70.out
@echo -----------------------------------------------------------------------------------------------------------------


cd "%CSP_DIR%"

@echo Creating Store Procedures.....
@echo -----------------------------------------------------------------------------------------------------------------
if %ALIAS%=="Y" (db2 connect to %DB% user %DBUSER% using %DBPASS%
) else db2 connect to %DB% user %USR% using %PWRD%
if %ERRORLEVEL%  NEQ   0 goto :error_connect

call createsp > %LOG_DIR%createsp.out
@echo -----------------------------------------------------------------------------------------------------------------


@echo Binding the code.....
@echo -----------------------------------------------------------------------------------------------------------------
db2 force applications all
db2stop force
db2start
if %ALIAS%=="Y" (db2 connect to %DB% user %DBUSER% using %DBPASS%
) else db2 connect to %DB% user %USR% using %PWRD%
if %ERRORLEVEL%  NEQ   0 goto :error_connect

if %ALIAS%=="Y" (call bindall %DBUSER% > %LOG_DIR%bindall.out
) else call bindall %TBSCHEM% > %LOG_DIR%bindall.out
@echo -----------------------------------------------------------------------------------------------------------------


cd %MIG_DIR%

@echo Finalizing the migration.....
@echo -----------------------------------------------------------------------------------------------------------------
if %ALIAS%=="Y" (db2 connect to %DB% user %DBUSER% using %DBPASS%
) else db2 connect to %DB% user %USR% using %PWRD%
if %ERRORLEVEL%  NEQ   0 goto :error_connect

db2 SET CURRENT SCHEMA %TBSCHEM%
if %ERRORLEVEL%  NEQ   0 goto :error_schema 
db2 -tvf custom_pivot_initdb.sql > %LOG_DIR%custom_pivot_initdb.out
@echo -----------------------------------------------------------------------------------------------------------------
 


@echo Checking db objects after database migration.....
@echo -----------------------------------------------------------------------------------------------------------------
db2 connect to %DB% user %USR% using %PWRD%

@echo Checking the count of RPM tables in your database.....
db2 -x "SELECT 'SET TABLE_COUNT=' || cast(count(tabname) as CHAR(7)) from syscat.tables where taBSCHEMA=upper('%TBSCHEM%') and TBSPACE not like 'USERSPACE1'" > %LOG_DIR%table_count.bat

CALL %LOG_DIR%table_count.bat

@echo Checking the count of RPM indexes in your database......

db2 -x "SELECT 'SET INDEX_COUNT=' || cast(count(indname) as CHAR(7)) from syscat.indexes where indSCHEMA=upper('%TBSCHEM%') and TBSPACEID  <> 2" > %LOG_DIR%index_count.bat

CALL %LOG_DIR%index_count.bat

@echo Checking the count of RPM triggers in your database......

db2 -x "SELECT 'SET TRIGGER_COUNT=' || cast(count(trigname) as CHAR(7)) from syscat.triggers where trigschema=upper('%TBSCHEM%')" > %LOG_DIR%trigger_count.bat

CALL %LOG_DIR%trigger_count.bat

@echo Checking the count of RPM UDFs in your database......
db2 -x "SELECT 'SET FUNCTION_COUNT=' || cast(count(funcname) as CHAR(7)) from syscat.functions where funcschema=upper('%TBSCHEM%')" > %LOG_DIR%function_count.bat

CALL %LOG_DIR%function_count.bat


@echo Checking the count of RPM stored procedures in your database......

db2 -x "SELECT 'SET PROC_COUNT=' || cast(count(procname) as CHAR(7))  from syscat.PROCEDURES where procschema=upper('%TBSCHEM%')" > %LOG_DIR%proc_count.bat

CALL %LOG_DIR%proc_count.bat

@echo Printing the results.....
@echo -----------------------------------------------------------------------------------------------------------------
if %TABLE_COUNT% == 192 (@echo THE TABLE COUNT IS CORRECT.
) else @echo THE TABLE COUNT MISMATCH.

if %INDEX_COUNT% == 484 (@echo THE INDEX COUNT IS CORRECT.
) else @echo THE INDEX COUNT MISMATCH.

if %TRIGGER_COUNT% == 78 (@echo THE TRIGGER COUNT IS CORRECT.
) else @echo THE TRIGGER COUNT MISMATCH.

if %FUNCTION_COUNT% == 40 (@echo THE UDF COUNT IS CORRECT.
) else @echo THE UDF COUNT MISMATCH.

if %PROC_COUNT% == 1036 (@echo THE STORED PROCEDURE COUNT IS CORRECT.
) else @echo THE STORED PROCEDURE COUNT MISMATCH.


@echo Printing the output for the above results into %LOG_DIR%DB_CHECK.out
@echo Please verify the results in the file and in case of differences contact RPM support.

@echo THE DETAILS OF YOUR CURRENT DB OBJECTS AND RPM REQUIRED DB OBJECTS >> %LOG_DIR%DB_CHECK.out
@echo ***********************************************************************************************
@echo Your current table count: %TABLE_COUNT% RPM table count: 192 >> %LOG_DIR%DB_CHECK.out
@echo Your current index count: %INDEX_COUNT% RPM index count: 484 >> %LOG_DIR%DB_CHECK.out
@echo Your current trigger count: %TRIGGER_COUNT% RPM trigger count: 78 >> %LOG_DIR%DB_CHECK.out
@echo Your current UDF count: %FUNCTION_COUNT% RPM UDF count: 40 >> %LOG_DIR%DB_CHECK.out
@echo Your current store procedure count: %PROC_COUNT% RPM store procedure count: 1036 >> %LOG_DIR%DB_CHECK.out


@echo Checking for successful database code migration.....
@echo -----------------------------------------------------------------------------------------------------------------
if %ALIAS%=="Y" (db2 connect to %DB% user %DBUSER% using %DBPASS%
) else db2 connect to %DB% user %USR% using %PWRD%

if %ERRORLEVEL%  NEQ   0 goto :error_connect


db2 SET CURRENT SCHEMA %TBSCHEM%
if %ERRORLEVEL%  NEQ   0 goto :error_schema 

db2 call sp_get_version()
if %ERRORLEVEL%  NEQ   0 (@echo Your RPM database code is not migrated successfully. Check the output files in %LOG_DIR%.
goto :done
) else @echo Your RPM database code has been upgraded successfully. Congratulations.
db2 connect reset
@echo -----------------------------------------------------------------------------------------------------------------




goto :done


:error_connect
echo One of the parameters specified to connect to the database is incorrect
goto :done
@echo off

:error_schema
echo Schema name %TBSCHEM% is undefined Provide the right schema name
goto :done
@echo off

:rename_error
@echo cannot rename IBMRPM.dll to IBMRPM_7000.dll in "%DB2TEMPDIR%"function and  "%DB2TEMPDIR%"function\unfenced\ folders therefore cannot copy
@echo IBMRPM.dll from "%CSP_DIR%" folder into "%DB2TEMPDIR%"function\ or "%DB2TEMPDIR%"function\unfenced\ folder.
@echo Please copy it manually before starting the migration.
goto :done

:copy_error
@echo Cannot copy IBMRPM.dll from "%CSP_DIR%" folder into "%DB2TEMPDIR%"function\ or "%DB2TEMPDIR%"function\unfenced\ folder.
@echo Please copy it manually before starting the migration.
goto :done

:done
set DB=
set USR=
set PWRD=
set DBUSER=
set DBPASS=
set TBSCHEM=
set ALIAS=
set VERSION=
set response=
set TABLE_COUNT=
set INDEX_COUNT=
set TRIGGER_COUNT=
set FUNCTION_COUNT=
set PROC_COUNT=
set ERRORLEVEL=0